/*
bttravgt.c Version 0.2.0  Btree read block in traverse
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void bttravgt(bthdr,ofst,blk)
btreefmt *bthdr;
off_t ofst;
blkfmt *blk;
   {
   off_t loc;
   int rdlen;
   bthdr->reason = 0;
   loc = btseek(bthdr,ofst);
   if (bthdr->reason) return;
   rdlen = read(bthdr->hndl,blk,bthdr->blksz);
   if (rdlen == bthdr->blksz) return;
   else if (rdlen < 0)
      {
      fprintf(stderr,"Error reading database "
	 "ofst %08x blksz %d rcdlen %d)\n",
	 (unsigned int) ofst,
	 bthdr->blksz, rdlen);
      fprintf(stderr,"hndl %d loc %u errno %d\n",
	 bthdr->hndl,
	 (unsigned int) loc,
	 errno);
      perror("Read error");
      bthdr->reason = SYS_ERR + errno;
      return;
      } /* read err */
   else
      {
      fprintf(stderr,"Error reading database "
	 "ofst %08x blksz %d rcdlen %d)\n",
	 (unsigned int) ofst,
	 bthdr->blksz, rdlen);
      bthdr->reason = BTREE_ERR + 601;
      return;
      } /* read err */
   } /* bttravgt */
